local lgr = love.graphics
local win = love.window
local lfs = love.filesystem
local kbd = love.keyboard
local tmr = love.timer

smbParticle = {}

function smbParticle:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v or {})
	return _i
end
function smbParticle:setup(v)
	self.life = v.life or 10
	self.x = v.x or 0
	self.y = v.y or 0
	self.vx = v.vx or 0
	self.vy = v.vy or -50
	self.gravity = v.gravity or 100
	self.color = v.color or {255,0,0}
	self.isDead = false
	self.shape = v.shape or "circle"
end

function smbParticle:update(dt)
	if self.isDead then return false end

	self.vy = self.vy + self.gravity * dt
	self.x = self.x + dt * self.vx
	self.y = self.y + dt * self.vy

	self.life = self.life - dt
	if self.life < 0 then
		self.life = 0
		self.isDead = true
	end
end

function smbParticle:draw()
	lgr.setColor(self.color)
	if self.shape == "square" then
		lgr.push()
		lgr.translate(self.x, self.y)
		lgr.scale(math.min(self.life, 1))
		lgr.rectangle("fill", -2, -2, 4, 4)
		lgr.pop()
	else
		lgr.circle("fill", self.x, self.y, 2 * self.life)
	end
end

function smbParticle:destroy()

end
