local lgr = love.graphics

objectDraw = {}

function objectDraw:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v or {})
	return _i
end
function objectDraw:setup(v)
	self.objectList = {}
end

function objectDraw:push(obj)
	if not obj.z then obj.z = math.random(1,100000) end
	self.objectList[#self.objectList+1] = obj
end

function objectDraw:prepare()
	self.objectList = {}
end

function objectDraw:draw()
	table.sort(self.objectList, function(a, b) return a.z < b.z end)

	for i, o in pairs(self.objectList) do
		lgr.setColor(o.color or {255,255,255})

		if o.type == "rectangle" then
			lgr.rectangle(o.fill, o.x, o.y, o.width, o.height)
		elseif o.type == "text" then
			if o.font then lgr.setFont(o.font) end
			if o.limit then
				lgr.printf(o.text, o.x, o.y, o.limit, o.align )
			else
				lgr.print(o.text, o.x, o.y, o.rotation, o.sx, o.sy, o.ox, o.oy, o.kx, o.ky)
			end
		end
	end
end
