local trail = {}
function trail:init(v)
   local _i = {}
   setmetatable(_i, {__index = self})
   _i:setup(v or {})
   return _i
end
function trail:setup(v)
   self.parent = v.parent
   self.active = false

   self:start(v)
end

function trail:update(dt)
   if self.active then
      for i = math.max(self.trailNum - self.trailMax + 1, 1), self.trailNum do
         local j = self.trailNum - i

         if j == 0 or j == 8 or j == 16 or j == 24 or j == 32 or j == 40 then
            self.drawLocations[(j / 8) + 1] = { x = self.trail[i].x, y = self.trail[i].y, z = self.trail[i].z, facing = self.trail[i].facing }
         end
      end
   end
end

function trail:getLocations()
   return self.drawLocations
end

function trail:stop()
   self.active = false
   cron.cancel(self.cron)
end

function trail:reset(v)
   local v = v or {}
   self.trail = {}
   self.drawLocations = {}
   self.trailMax = v.max or 51
   self.trailNum = v.min or 51
   for i = 1, 100 do
      self.trail[i] = {
         x = self.parent.x, y = self.parent.y, z = self.parent.z, facing = self.parent.facing
      }
   end
end

function trail:start(v)
   local v = v or {}
   self:reset(v)
   self.active = true

   self.cron = cron.every(1/60, function()
      if self.parent.moving and self.active then
         self.trailNum = self.trailNum + 1
         self.trail[self.trailNum] = {
            x = self.parent.x, y = self.parent.y, z = self.parent.z, facing = self.parent.facing
         }
         if #self.trail > self.trailMax then
            self.trail[self.trailNum - self.trailMax] = nil
         end
      end
   end)
end

return trail
