local lgr = love.graphics
local win = love.window

primitive = {}

local drawPrimitive = {
	["circle"] = function(self)
		lgr.setColor(self.color[1], self.color[2], self.color[3], self.opacity * 255)
		lgr.circle(self.fill, self.x, self.y, self.radius, self.detail)
	end
}

function primitive:create(v)
	local _i = {}
	setmetatable(_i, {__index = self})
	_i:setup(v or {})
	return _i
end
function primitive:setup(v)
	self.type = v.type or "circle"
	self.color = v.color or {255,255,255}
	self.opacity = v.opacity or 1

	self.x = v.x or 0
	self.y = v.y or 0
	self.z = v.z or 1

	self.tweens = {}

	if self.type == "circle" then
		self.radius = v.radius or 16
		self.fill = v.fill or "fill"
		self.detail = v.detail or nil
	end

	self.delete = false
end

function primitive:update(dt)
	-- for i, f in pairs(self.tweens) do
	-- 	f:update(dt)
	-- end
end

function primitive:draw()
	drawPrimitive[self.type](self)
end

